ents = {}
ents.objects = {}
ents.objpath = "entities/"
local register = {}
local id = 0

function ents.Startup()
	register["player"] = love.filesystem.load( ents.objpath .. "player.lua" )
	register["badball"] = love.filesystem.load( ents.objpath .. "badball.lua" )
	register["badbartop"] = love.filesystem.load( ents.objpath .. "badbartop.lua" )
	register["badbarmid"] = love.filesystem.load( ents.objpath .. "badbarmid.lua" )
	register["badbarbottom"] = love.filesystem.load( ents.objpath .. "badbarbottom.lua" )
	register["madbar"] = love.filesystem.load( ents.objpath .. "madbar.lua" )
end

function ents.Derive(name)
	return love.filesystem.load( ents.objpath .. name .. ".lua" )()
end

function ents.Create(name, x, y)
	if not x then
		x = 0
	end
	
	if not y then
		y = 0
	end
	
	if register[name] then
		id = id + 1
		local ent = register[name]()
		ent:load()
		ent.type = name
		ent:setPos(x, y)
		ent.id = id
		ents.objects[id] = ent
		return ents.objects[id]
	else
		print("error: entity " .. name .. " does not exist.")
		return false;
	end
end

function ents:update(dt)
   	for i, ent in pairs(ents.objects) do
		if ent.update then
			ent:update(dt)
		end
	end
end

function ents:draw()
	for i, ent in pairs(ents.objects) do
		if ent.draw then
			ent:draw()
		end
	end
end

function ents.crash( x, y )
	for i, ent in pairs(ents.objects) do
		if ent.type == "madbar" then
			local crash = insideBox( x, y, ent.x, ent.y, 10, 200 )
			if crash then
				print("hit orange bar~~")
			end
		end
		if ent.type == "badbartop" then
			local crash = insideBox( x, y, ent.x, ent.y, 10, 400 )
			if crash then
				print("hit top bar~~")
			end
		end
		if ent.type == "badbarbottom" then
			local crash = insideBox( x, y, ent.x, ent.y, 10, 400 )
			if crash then
				print("hit bottom bar~~")
			end
		end
		if ent.type == "badbarmid" then
			local crash = insideBox( x, y, ent.x, ent.y, 10, 200 )
			if crash then
				print("hit mid bar~~")
			end
		end
		if ent.type == "badball" then
			local crash = insideBox( x, y, ent.x, ent.y, 24, 24 )
			if crash then
				print("hit ball~~")
			end
		end
	end
end